The Red Matrix
==============


The modern web is "missing" a few important pieces which would make it much more useful. Many corporations have stepped in with products to supply these missing pieces, but with a loss of freedom and privacy and increased **centralisation**. 

Centralisation is generally considered a bad thing in network design as the loss of one critical node or centralised service could seriously impact the entire network - possibly taking a long time to recover. Recognising this, the original web was based on decentralised services. Over the years, this fundamental design strength has been largely overlooked, as people congregate into centralised services which provide the missing pieces. 

These missing pieces are (in no particular order):

- Secure and private "spam free" communications

- Identity and "single-signon" across the entire network

- Privacy controls and permissions which extend to the entire network

- Directory services (like a phone book)



The Red Matrix (sometimes referred to as just "Red") is a collection of web servers and services which provides these missing pieces, but within a decentralised framework. It operates as an independant network within the larger internet where all the nodes or servers (we call them "hubs") are able to fully interact with each other in ways that are simply not possible using legacy service providers. Additionally the owners of each network hub have the ability to set their own rules with regard to communications and privacy and data ownership, because each operates with complete independance.

![The Red Matrix model](images/red_antiprism.png)


Several projects exist today which attempt to provide one or more of these missing pieces, such as decentralised communications or single-signon. The Red Matrix tries to look at the bigger picture and provide them all. One of the weaknesses of many/most existing decentralised network models is the binding of network identity with the physical server where it resides. The problem with this is that many of these projects are somewhat experimental in nature and the technology is changing quite rapidly. Sometimes the burden or cost of maintaining these services becomes a burden (or hardware fails) and people or social communities are left stranded. They may have to "start over" building their social circle from scratch when this happens; because their online identity is tied to that physical server. We've been working on decentralisation for several years and have seen this happen time and time again. Often the hassle involved in re-establishing network contacts is too great, and causes the person to give up and go back to centralised services; thinking they are immune to this problem. (They are to some extent, as long as the parent company is stable and profitable; otherwise the same problem manifests itself on a much larger scale).  

Within the Red Matrix, identity is nomadic. You can take your identity, and all your friends and associates with you - to any other hub in the network, at any time. If your hub goes offline for any reason, you have the ability to relocate to any other hub and carry on as if nothing happened. Your friends and associates are still there.

 
The Red Matrix is free and open source distributed under the MIT license.


Currently the project is in "Developer Preview". A lot of work remains, but many important bits are functioning. Please connect with one of the developer channels ("Channel One" would be a good choice) if you are interested in helping us out. 
